<?php

// Check nonce
PHPCUS_PARAM::CUS_REQUIRES_NONCE();

// Dismiss Session
PHPVC_SESSION::VAR_STOP();
	
// Check Array Input
PHPCUS_PARAM::CUS_DOES_NOT_SUPPORT_ARRAY();

// Check already authenticated
PHPCUS_PARAM::CUS_REQUIRES_AUTHENTICATION();

// Check access rights
// PHPCUS_PARAM::CUS_HAS_PERMISSION(PHPCUS_SYSTEM::AUTHORITY_VIEW_ONLY, 'account_level');

if
(
    PHPRC_HTTP_PARAM::REF_ISSET_IN_ARRAY
    (
        [
            'PARAM_ACC_LEVEL_ID',
            'PARAM_ACC_LEVEL_SERVER_ID',
            'PARAM_ACC_LEVEL_TAG_ID',
            'PARAM_ACC_LEVEL_DESCRIPTION',
            'PARAM_ACC_LEVEL_STATUS',
            'PARAM_ACC_LEVEL_SYSTEM_GENERATED',
            
            'PARAM_ORDER_FIELD',
            'PARAM_ORDER_TYPE',
            'PARAM_SKIP',
            'PARAM_LIMIT'
        ], True
        )
    )
{
    Try
    {
        // Read params
        // ------------------------------------------------------------------
        $PARAM_ACC_LEVEL_ID = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_ACC_LEVEL_ID');
        $PARAM_ACC_LEVEL_SERVER_ID = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_ACC_LEVEL_SERVER_ID');
        $PARAM_ACC_LEVEL_TAG_ID = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_ACC_LEVEL_TAG_ID');
        $PARAM_ACC_LEVEL_DESCRIPTION = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_ACC_LEVEL_DESCRIPTION');
        $PARAM_ACC_LEVEL_STATUS = PHPCUS_PARAM::CUS_READ_INT('PARAM_ACC_LEVEL_STATUS');
        $PARAM_ACC_LEVEL_SYSTEM_GENERATED = PHPCUS_PARAM::CUS_READ_INT('PARAM_ACC_LEVEL_SYSTEM_GENERATED');
        
        $PARAM_ORDER_FIELD = PHPCUS_PARAM::CUS_READ_SORT_FIELD
        (
            'PARAM_ORDER_FIELD',
            [
                'ACC_LEVEL_ID',
                'ACC_LEVEL_SERVER_ID',
                'ACC_LEVEL_TAG_ID',
                'ACC_LEVEL_DESCRIPTION',
                'ACC_LEVEL_STATUS',
                'ACC_LEVEL_SYSTEM_GENERATED'
            ]
            );
        $PARAM_ORDER_TYPE = PHPCUS_PARAM::CUS_READ_SORT_TYPE('PARAM_ORDER_TYPE');
        $PARAM_SKIP	= PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_SKIP');
        $PARAM_LIMIT = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_LIMIT');
        
        // ------------------------------------------------------------------
        
        
        // Populate Map Array
        // ...........................................
        $GET_MAP_ARRAY = PHPCUS_ACCOUNT_LEVEL::CUS_PREPARE_MAPPED_ARRAY_FOR_GET();
        
        $GET_MAP_ARRAY['PARAM_ACC_LEVEL_ID'] = $PARAM_ACC_LEVEL_ID;
        $GET_MAP_ARRAY['PARAM_ACC_LEVEL_SERVER_ID'] = $PARAM_ACC_LEVEL_SERVER_ID;
        $GET_MAP_ARRAY['PARAM_ACC_LEVEL_TAG_ID'] = $PARAM_ACC_LEVEL_TAG_ID;
        $GET_MAP_ARRAY['PARAM_ACC_LEVEL_DESCRIPTION'] = $PARAM_ACC_LEVEL_DESCRIPTION;
        $GET_MAP_ARRAY['PARAM_ACC_LEVEL_STATUS'] = $PARAM_ACC_LEVEL_STATUS;
        $GET_MAP_ARRAY['PARAM_ACC_LEVEL_SYSTEM_GENERATED'] = $PARAM_ACC_LEVEL_SYSTEM_GENERATED;
        
        $GET_MAP_ARRAY["PARAM_ORDER_FIELD"] = $PARAM_ORDER_FIELD;
        $GET_MAP_ARRAY["PARAM_ORDER_TYPE"] = $PARAM_ORDER_TYPE;
        $GET_MAP_ARRAY["PARAM_SKIP"] = $PARAM_SKIP;
        $GET_MAP_ARRAY["PARAM_LIMIT"] = $PARAM_LIMIT;
        
        
        // Execute Stored Procedure
        // ...........................................
        $DATA_SET = PHPCUS_ACCOUNT_LEVEL::CUS_GET_MA($GET_MAP_ARRAY);
        
        
        // Return JSON response
        // ...........................................
        if(empty($DATA_SET) === False)
        {
            PHPCUS_PARAM::CUS_JSON_SUCCESS($DATA_SET);
        }
        else
        {
            PHPCUS_PARAM::CUS_JSON_SUCCESS('');
        }
        
    }
    Catch(Exception $ERR)
    {
        PHPVC_LOG::VAR_REPORT_ERROR($ERR, 0);
        PHPCUS_PARAM::CUS_JSON_ERROR($ERR->getMessage());
    }
}
else
{
    PHPCUS_PARAM::CUS_JSON_ERROR('Missing parameters');
}

?>